%http://www.mathworks.com/products/statistics/demos.html?file=/products/demos/shipping/stats/classdemo.html#1

%Ce fichier existe dans MatLab
load fisheriris
%permet de rcuprer la matrice meas reprsentant les fleurs Iris dans cet
%ordre : Setosa, versicolor, virginica, 50 chantillons (lignes) chacune
meas1=meas(:,1);%longueurs des ptales 
meas2=meas(:,2);%largeurs des ptales 
speciesVar=species; %donne les espces


figure

% distribution
gscatter(meas(:,1), meas(:,2), species,'rgb','osd');
xlabel('Sepal length');
ylabel('Sepal width');
N = size(meas,1);
pause

% reprage des mauvaises classifications
ldaClass = classify(meas(:,1:2),meas(:,1:2),species);
bad = ~strcmp(ldaClass,species);
ldaResubErr = sum(bad) / N;
[ldaResubCM,grpOrder] = confusionmat(species,ldaClass)
hold on;
plot(meas(bad,1), meas(bad,2), 'kx');
hold off;
pause

%
figure
[x,y] = meshgrid(4:.1:8,2:.1:4.5);
x = x(:);
y = y(:);
j = classify([x y],meas(:,1:2),species);
gscatter(x,y,j,'grb','sod')
pause

%Compute the resubstitution error for quadratic discriminant analysis.
qdaClass = classify(meas(:,1:2),meas(:,1:2),species,'quadratic');
bad = ~strcmp(qdaClass,species);
qdaResubErr = sum(bad) / N
hold on;
plot(meas(bad,1), meas(bad,2), 'kx');
pause

%Validation croise
%Gnration alatoire des ensembles
disp('erreur de cross validation par LDA')
s = RandStream('mt19937ar','seed',0);
RandStream.setDefaultStream(s);
cp = cvpartition(species,'k',10)
ldaClassFun= @(xtrain,ytrain,xtest)(classify(xtest,xtrain,ytrain));
ldaCVErr  = crossval('mcr',meas(:,1:2),species,'predfun', ...
             ldaClassFun,'partition',cp)
pause
disp('erreur de cross validation par LDA')         
%Estimate the true test error for QDA using 10-fold stratified cross-validation.
qdaClassFun = @(xtrain,ytrain,xtest)(classify(xtest,xtrain,ytrain,...
              'quadratic'));
qdaCVErr = crossval('mcr',meas(:,1:2),species,'predfun',...
           qdaClassFun,'partition',cp)
pause

disp('erreur de cross validation par LDA pour Bayes naf')
%NaiveBayes Classifier
nbGau= NaiveBayes.fit(meas(:,1:2), species);
nbGauClass= nbGau.predict(meas(:,1:2));
bad = ~strcmp(nbGauClass,species);
nbGauResubErr = sum(bad) / N
nbGauClassFun = @(xtrain,ytrain,xtest)...
               (predict(NaiveBayes.fit(xtrain,ytrain), xtest));
nbGauCVErr  = crossval('mcr',meas(:,1:2),species,...
              'predfun', nbGauClassFun,'partition',cp)
          
hold on
plot(meas(bad,1), meas(bad,2), 'kx'); 


pause
disp('erreur de cross validation par LDA pour une fonction noyau')
nbKD= NaiveBayes.fit(meas(:,1:2), species,'dist','kernel');
nbKDClass= nbKD.predict(meas(:,1:2));
bad = ~strcmp(nbKDClass,species);
nbKDResubErr = sum(bad) / N
nbKDClassFun = @(xtrain,ytrain,xtest)...
            (predict(NaiveBayes.fit(xtrain,ytrain,'dist','kernel'),xtest));
nbKDCVErr = crossval('mcr',meas(:,1:2),species,...
            'predfun', nbKDClassFun,'partition',cp)
hold on
plot(meas(bad,1), meas(bad,2), 'ko');
hold off;
         
%Arbre de dcision
t = classregtree(meas(:,1:2), species,'names',{'SL' 'SW' });
[grpname,node] = t.eval([x y]);
figure
gscatter(x,y,grpname,'grb','sod')

view(t);

%Compute the resubstitution error and the cross-validation error for decision tree.
dtclass = t.eval(meas(:,1:2));
bad = ~strcmp(dtclass,species);
dtResubErr = sum(bad) / N

dtClassFun = @(xtrain,ytrain,xtest)(eval(classregtree(xtrain,ytrain),xtest))
;
dtCVErr  = crossval('mcr',meas(:,1:2),species, ...
          'predfun', dtClassFun,'partition',cp)
      
%Try pruning the tree      
resubcost = test(t,'resub');
[cost,secost,ntermnodes,bestlevel] = test(t,'cross',meas(:,1:2),species);
plot(ntermnodes,cost,'b-', ntermnodes,resubcost,'r--')
figure(gcf);
xlabel('Number of terminal nodes');
ylabel('Cost (misclassification error)')
legend('Cross-validation','Resubstitution')

[mincost,minloc] = min(cost);
cutoff = mincost + secost(minloc);
hold on
plot([0 20], [cutoff cutoff], 'k:')
plot(ntermnodes(bestlevel+1), cost(bestlevel+1), 'mo')
legend('Cross-validation','Resubstitution','Min + 1 std. err.','Best choice')
hold off

%You can show this on the graph by computing a cutoff value that is equal to the minimum cost plus one standard error
[mincost,minloc] = min(cost);
cutoff = mincost + secost(minloc);
hold on
plot([0 20], [cutoff cutoff], 'k:')
plot(ntermnodes(bestlevel+1), cost(bestlevel+1), 'mo')
legend('Cross-validation','Resubstitution','Min + 1 std. err.','Best choice')
hold off

pt = prune(t,bestlevel);
view(pt)