function [ desc ] = Dradon( im, angle_p )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Santosh
% information:
% it provides profiles depending on the projection angle_p
% it provides projection profile of different sizes according to the size of the images.
%%%%%%%%%%%%%%%%
% im = binary image;
% angle_p = projection angle i.e., 180/angle_p
%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
%% 1. Radon transform 
     theta = [0:179];
     [R, Xp] = radon(im, theta);   
    
%% 2. Projection profile Normalisation
[r, c] = size(matrix);
maxColVector = max(matrix, [], 1);
for i = 1:r
    for j = 1:c
        result(i,j) = matrix(i,j)/maxColVector(j);
    end
end
R_matrix = result;


%% 3. getting specific number of projection
for i = 0:angle_p:180-angle_p
    result = sum([R_matrix(:, i+1:i+angle_p)'])/angle_p;
end

%% 4. descriptor will be of size [180/angle_p, \rho]
desc = result;

end




