function [ Distance ] = Dradon_dist (qt, dt, angle_p)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Santosh
% qt = query descriptor.
% dt = database descriptor.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 1. define parameters
B = 180/angle_p;

for i = 1:B
       D(i) = DTW_weighted_measure (qt(:,i)', dt(:,i)');
end

%% 2. global distance.
Distance = sum(D)/B;
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [ D_weighted ] = DTW_weighted_measure( t, r )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Santosh
% [ average ] = DTW_weighted( t, r )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% calcualte diagonal matrix <<backward>> 
	[rows,N]=size(t);
	[rows,M]=size(r);

%% non-weighted distance :: return
	D = DTWmatrix (t,r, N, M);
	D_nonweighted = D(N,M);

%% for weighted distance weight
	n=N;
	m=M;
	k=1;
	w=[];
	w(1,:)=[N,M];
	while ((n+m)~=2)
    		if (n-1)==0
		        m=m-1;
	    elseif (m-1)==0
		        n=n-1;
	    else 
	      [values,number]=min([D(n-1,m),D(n,m-1),D(n-1,m-1)]);
	      switch number
	      case 1
	        n=n-1;
	      case 2
	        m=m-1;
	      case 3
	        n=n-1;
	        m=m-1;
	      end
	  end
	    k=k+1;
	end
%% weighted distance :: return 
	D_weighted = D_nonweighted/(k-1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [ Dmatrix ] = DTWmatrix (t, r, N, M)

	d=(repmat(t(:),1,M)-repmat(r(:)',N,1)).^2; %this replaces the nested for loops from above Thanks Georg Schmitz 

	D=zeros(size(d));
	D(1,1)=d(1,1);

	for n=2:N
    		D(n,1)=d(n,1)+D(n-1,1);
	end

	for m=2:M
    		D(1,m)=d(1,m)+D(1,m-1);
	end

	for n=2:N
	    for m=2:M
        	D(n,m)=d(n,m)+min([D(n-1,m),D(n-1,m-1),D(n,m-1)]);
	    end
	end
	Dmatrix = D;
end

