function [teta idx_teta maximunintensity]=WVD_orientation(BW)

%Cette algorithme trouve l'orientation du l'image,
%BW est l'image en binaire
%il est inspir de l'article 

%Skew angle estimation for printed and handwritten documents using the Wigner-Ville distribution

%Authors: Kavallieratou E.1; Fakotakis N.; Kokkinakis G.

%Source: Image and Vision Computing, Volume 20, Number 11, 1 September 2002 , pp. 813-824(12)

%Publisher: Elsevier


%% WVD Algo

%-75 -60 -45 -30 -15 0 15 30 45 60 75 90
vectN75=tetaprojection(BW,-75);
vectN60=tetaprojection(BW,-60);
vectN45=tetaprojection(BW,-45);
vectN30=tetaprojection(BW,-30);
vectN15=tetaprojection(BW,-15);
vect0=tetaprojection(BW,0);
vect15=tetaprojection(BW,15);
vect30=tetaprojection(BW,30);
vect45=tetaprojection(BW,45);
vect60=tetaprojection(BW,60);
vect75=tetaprojection(BW,75);
vect90=tetaprojection(BW,90);


%% -75
saN75=[vectN75;1:length(vectN75)];
saN75R1=rot90(saN75);
saN75R2=rot90(saN75R1);
saN75R3=rot90(saN75R2);
[tfr,t,f] = tfrwv(saN75R3(:,2));
maximunintensity(1)=max(max(tfr));

%% -60
saN60=[vectN60;1:length(vectN60)];
saN60R1=rot90(saN60);
saN60R2=rot90(saN60R1);
saN60R3=rot90(saN60R2);
[tfr,t,f] = tfrwv(saN60R3(:,2));
maximunintensity(2)=max(max(tfr));

%% -45
saN45=[vectN45;1:length(vectN45)];
saN45R1=rot90(saN45);
saN45R2=rot90(saN45R1);
saN45R3=rot90(saN45R2);
[tfr,t,f] = tfrwv(saN45R3(:,2));
maximunintensity(3)=max(max(tfr));

%% -30
saN30=[vectN30;1:length(vectN30)];
saN30R1=rot90(saN30);
saN30R2=rot90(saN30R1);
saN30R3=rot90(saN30R2);
[tfr,t,f] = tfrwv(saN30R3(:,2));
maximunintensity(4)=max(max(tfr));

%% -15
saN15=[vectN15;1:length(vectN15)];
saN15R1=rot90(saN15);
saN15R2=rot90(saN15R1);
saN15R3=rot90(saN15R2);
[tfr,t,f] = tfrwv(saN15R3(:,2));
maximunintensity(5)=max(max(tfr));

%% 0
sa0=[vect0;1:length(vect0)];
sa0R1=rot90(sa0);
sa0R2=rot90(sa0R1);
sa0R3=rot90(sa0R2);
[tfr,t,f] = tfrwv(sa0R3(:,2));
maximunintensity(6)=max(max(tfr));

%% 15
sa15=[vect15;1:length(vect15)];
sa15R1=rot90(sa15);
sa15R2=rot90(sa15R1);
sa15R3=rot90(sa15R2);
[tfr,t,f] = tfrwv(sa15R3(:,2));
maximunintensity(7)=max(max(tfr));

%% 30
sa30=[vect30;1:length(vect30)];
sa30R1=rot90(sa30);
sa30R2=rot90(sa30R1);
sa30R3=rot90(sa30R2);
[tfr,t,f] = tfrwv(sa30R3(:,2));
maximunintensity(8)=max(max(tfr));

%% 45
sa45=[vect45;1:length(vect45)];
sa45R1=rot90(sa45);
sa45R2=rot90(sa45R1);
sa45R3=rot90(sa45R2);
[tfr,t,f] = tfrwv(sa45R3(:,2));
maximunintensity(9)=max(max(tfr));

%% 60
sa60=[vect60;1:length(vect60)];
sa60R1=rot90(sa60);
sa60R2=rot90(sa60R1);
sa60R3=rot90(sa60R2);
[tfr,t,f] = tfrwv(sa60R3(:,2));
maximunintensity(10)=max(max(tfr));

%% 75
sa75=[vect75;1:length(vect75)];
sa75R1=rot90(sa75);
sa75R2=rot90(sa75R1);
sa75R3=rot90(sa75R2);
[tfr,t,f] = tfrwv(sa75R3(:,2));
maximunintensity(11)=max(max(tfr));

%% 90
sa90=[vect90;1:length(vect90)];
sa90R1=rot90(sa90);
sa90R2=rot90(sa90R1);
sa90R3=rot90(sa90R2);
[tfr,t,f] = tfrwv(sa90R3(:,2));
maximunintensity(12)=max(max(tfr));
Matrixproject=[1 -75;...
               2 -60;...
               3 -45;...
               4 -30;...
               5 -15;...
               6 0;...
               7 15;...
               8 30;...   
               9 45;...
               10 60;...
               11 75;...
               12  90;...
                   ];

[intensity_max idx]=max(maximunintensity);
teta =Matrixproject(idx,2);
idx_teta=idx;


