function [grapheme, up, low] = get_grapheme(img, oldUp, oldLow, noBB)
% Die Funktion GETGRAPHEME korregiert die Groesse des Images IMG auf die
% Groesse des enthaltenen Graphems und gibt dies zurueck. Weiter wird die
% Position des Basisbandes an die neue Groesse angepasst.

p = regionprops(double(img), 'BoundingBox');

left = round(p(1).BoundingBox(1));
minRow = round(p(1).BoundingBox(2));
width = round(p(1).BoundingBox(3));
height = round(p(1).BoundingBox(4));

if noBB
    if oldUp < minRow
        up = 1;
        upEnd = oldUp;
    else
        up = oldUp - minRow + 1;
        upEnd = minRow;
    end;
    
    low = oldLow - oldUp + up;
    
    if oldLow > minRow + height - 1
        lowEnd = oldLow;
    else
        lowEnd = minRow + height - 1;
    end;
else
    upEnd = minRow;
    lowEnd = minRow + height - 1;
    up = 1;
    low = height;
    
end

grapheme = img(upEnd:lowEnd,left:left+width-1);
