%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Santosh KC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x1 = contourPointsCur(:,1);
y1 = contourPointsCur(:,2);
t1 = contourPointsCur(:,3);
x2 = contourPoints(:,1);
y2 = contourPoints(:,2);
t2 = contourPoints(:,3);

N2 = max(max(x1),max(x2))+1;
N1 = max(max(y1),max(y2))+1;

if display_flag
   figure(1);
   
   subplot(2,2,1); 
   im1 = imread(fileName(i).name);
   imagesc(im1); axis('image');
   
   subplot(2,2,2); 
   im2 = imread(fileName(j).name);
   imagesc(im2); axis('image');
   
   colormap(gray)
   drawnow
end

X = [x1 y1];
Y = [x2 y2];

if display_flag
   subplot(2,2,3)
   plot(X(:,1),X(:,2),'b+')
   hold on
   quiver(X(:,1),X(:,2),cos(t1),sin(t1),0.5,'b')
   hold off
   axis('ij'); axis([1 N2 1 N1])
   title([int2str(length(x1)) ' samples'])
   
   subplot(2,2,4)
   plot(Y(:,1),Y(:,2),'ro')
   hold on
   quiver(Y(:,1),Y(:,2),cos(t2),sin(t2),0.5,'r.')
   hold off
   axis('ij'); axis([1 N2 1 N1])
   title([int2str(length(x2)) ' samples'])
   
   drawnow	
end

if display_flag
   [x,y] = meshgrid(linspace(1,N2,36),linspace(1,N1,36));
   x = x(:); y = y(:); M = length(x);
end

%%% compute correspondences
Xk = X;
tk = t1;
k = 1;
ndum = round(ndum_frac*nsamp);
out_vec_1 = zeros(1,nsamp);
out_vec_2 = zeros(1,nsamp);

% disp('computing shape contexts for (deformed) model...')
[BH1,mean_dist_1] = sc_compute(Xk',zeros(1,nsamp),mean_dist_global,...
    nbins_theta,nbins_r,r_inner,r_outer,out_vec_1);
% disp('computing shape contexts for target...')
[BH2,mean_dist_2] = sc_compute(Y',zeros(1,nsamp),mean_dist_global,...
    nbins_theta,nbins_r,r_inner,r_outer,out_vec_2);

if affine_start_flag
	if k == 1
        % use huge regularization to get affine behavior
        lambda_o = 1000;
    else
        lambda_o = beta_init*r^(k-2);
    end
else
    lambda_o = beta_init*r^(k-1);
end
beta_k = (mean_dist_2^2)*lambda_o;

costmat_shape = hist_cost_2(BH1,BH2);
theta_diff = repmat(tk,1,nsamp)-repmat(t2',nsamp,1);
% costmat_theta=abs(atan2(sin(theta_diff),cos(theta_diff)))/pi;
if polarity_flag
	% use edge polarity
    costmat_theta = 0.5*(1-cos(theta_diff));
else
    % ignore edge polarity
    costmat_theta = 0.5*(1-cos(2*theta_diff));
end      

costmat = (1-ori_weight)*costmat_shape+ori_weight*costmat_theta;


% calculate shape context cost
[a1,b1]=min(costmat,[],1);
[a2,b2]=min(costmat,[],2);
sc_cost=max(mean(a1),mean(a2));

shapeDist = sc_cost;
