function [snakeimage x y] = snakelineextractread(X)
%X est l'image
%% Initialization
addpath('gvf_v5');
addpath('tftb');
X=im2bw(X);
[a b]=size(X);
B=~zeros(a+10,b+10);
for i=1:a
for j=1:b
B(i+5,j+5)=X(i,j);
end
end
imintial=B;
%figure, imshow(B);
X=B;
[h w]=size(X);
%% dtermine degr
deg=0;
degtemp=-1*deg;
%% Dilatation
SE=strel('line',2,deg); 
X=imerode(X,SE);

%% Hole-Filling
RID=imfill(~X,'holes');
X=~RID;
%% Erosion
SE=strel('line',2,deg);
X=imdilate(X,SE);

figure('Toolbar','none','Name','Dilatation + Hole-Filling + Erosion ','NumberTitle','off'),imshow(X)

%% Read the image from FileName
I=X(:,:,1);
%% Compute its edge map
disp(' Compute edge map ...');
f = 1 - I/255;  
%% Compute the GVF of the edge map f
disp(' Compute GVF ...');
[u,v] = GVF(f, 0.2, 80); 
disp(' Nomalizing the GVF external force ...');
mag = sqrt(u.*u+v.*v);
px = u./(mag+1e-10); py = v./(mag+1e-10); 
%% display the gradient of the edge map
%    [fx,fy] = gradient(f); 
%  
%    subplot(223); quiver(fx,fy); 
%     axis off; axis equal; axis 'ij';     % fix the axis 
%      title('edge map gradient');
%% snake points
BW=im2bw(X);
comp=imcomplement(BW);
%Calculer les composantes connexes
[L,num] = bwlabel(comp,4);
%%[L,num] = bwlabel(~imintial,4);
%Calculer le centre de chaque composante connexe et le rayon du cercle qui
%l'entoure
reg=regionprops(L,'all');
figure('Toolbar','none','Name','Ellipse Draw','NumberTitle','off'),imshow(~comp)
%% Extralength
s=0;
for i=1:num
[r,c] = find(L==i);
maxr=max(r);
minr=min(r);
maxc=max(c);
minc=min(c);

%Dresser l'ellipse avec les deux axes (axe d'inertie)
an=reg(i).MajorAxisLength;
s=an+s;
end
%Extralength=double(s/num);
Extralength=0;
for i=1:num
[r,c] = find(L==i);
maxr=max(r);
minr=min(r);
maxc=max(c);
minc=min(c);

%Dresser l'ellipse avec les deux axes (axe d'inertie)
%Extralength
an=reg(i).MajorAxisLength;
if(an<=Extralength)
an=reg(i).MajorAxisLength*(1+1/Extralength);
else
 an=reg(i).MajorAxisLength+Extralength;
end
bn=reg(i).MinorAxisLength;
xn0=reg(i).Centroid(1);
yn0=reg(i).Centroid(2);
phin=reg(i).Orientation;
if(phin<0)
    phin=abs(phin);
elseif(phin>0)
        phin=-1*phin;
else
    phin=phin;
end

hold on
[out,outxx,outyy,mjr,mnr]=ellipse([an/2 bn/2],[xn0 yn0],degtemp,'Ellipse','off','Major','on','Minor','off');

%% Traitement de la taille de l'axe majeur 
for k=1:2
if(outxx(k)<0)
    outxx(k)=1;
end
if(outxx(k)>w)
    outxx(k)=w;
end
end

for l=1:2
if(outyy(l)<0)
    outyy(l)=1;
end
if(outyy(l)>h)
    outyy(l)=h-1;
end
end
%
outx(i)={outxx};
outy(i)={outyy};
[xx,yy] = snakeinterp(outx{i},outy{i},2,0.5);
x(i)={xx};
y(i)={yy};
for m=1:10, 
       [xx,yy] = snakedeform(x{i},y{i},0.1,0,1,0.6,px,py,5);
       x(i)={xx};
       y(i)={yy};
       [xx,yy] = snakeinterp(x{i},y{i},2,0.5);
       x(i)={xx};
       y(i)={yy};
end
end
%% Display the final result of the snake
figure('Toolbar','none','Name','Baby sankes deformation','NumberTitle','off'),imshow(I);
for i=1:num
hold on 
snakedisp(x{i},y{i},'r');
end

%% Replace each snake pixel by black pixel 1
for i=1:num
elx=numel(x{i});
xtemp=x{i};
ytemp=y{i};
for j=1:elx
if(~isnan(xtemp(j)) && ~isnan(ytemp(j)))
X(int16(ytemp(j)),int64(xtemp(j)))=0;
X(int16(ytemp(j)),int64(xtemp(j)+1))=0;
X(int16(ytemp(j)),int64(xtemp(j)-1))=0;
X(int16(ytemp(j)+1),int64(xtemp(j)))=0;
X(int16(ytemp(j)-1),int64(xtemp(j)))=0;
X(int16(ytemp(j)+1),int64(xtemp(j)+1))=0;
X(int16(ytemp(j)-1),int64(xtemp(j)-1))=0;
X(int16(ytemp(j)-1),int64(xtemp(j)+1))=0;
X(int16(ytemp(j)+1),int64(xtemp(j)-1))=0;
end
end
end
%% Hole-Filling
%figure('Toolbar','none','Name','Balck pixels are drawn in place of all baby sankes','NumberTitle','off'),imshow(X);

%% Delete the overlapped and touched compoenents
BW=im2bw(X);
comptemp=imcomplement(BW);
%Calculer les composantes connexes
[Ltemp,numtemp] = bwlabel(comptemp,4);
for i=1:numtemp
[r,c] = find(Ltemp==i);
maxr(i)=max(r);
minr(i)=min(r);
maxc(i)=max(c);
minc(i)=min(c);
widthccx(i)=maxr(i)-minr(i)+1;
heightccx(i)=maxc(i)-minc(i)+1;
end
widthavg=sum(widthccx)/numtemp;
heigthavg=sum(heightccx)/numtemp;
%figure,imshow(BW);
k=1;
for i=1:numtemp
    if(widthccx(i)>widthavg)
    overlapccx(k)=i;
    k=k+1;
   hold on
rectangle('position',[minc(i),minr(i),maxc(i)-minc(i)+1,maxr(i)-minr(i)+1],'edgecolor','r');%'facecolor','w');
    end
end
heightccx
heigthavg
%% result by colors
snakeimage=X;
comp=imcomplement(X);
[L1,numline] = bwlabel(comp,4);
RGB2 = label2rgb(L1, 'spring', 'w', 'shuffle');
%figure('Toolbar','none','Name','CCX color','NumberTitle','off'),imshow(RGB2);

%% Assign each connected components to its appropriate line
%1. Find the CCX of imintial
comp=imcomplement(imintial);
[L2,num] = bwlabel(comp,4);
ccxzonelines=zeros(numline,1);
g=1;
for i=1:w;
    for j=1:h;
        if(L1(j,i)~=0 && L2(j,i)~=0)
           ccxzonelines(L1(j,i),g)=L2(j,i);
           g=g+1;
        end
       
    end
end

% % for k=1:numline
% % A=ccxzonelines(k,:);
% % temp=0;
% % temp(1)=A(1);
% % c=2;
% % for i=2:numel(A)
% % a=find(temp==A(i));
% % if(numel(a)==0 && A(i)~=0)
% % temp(c)=A(i);c=c+1;
% % end
% % end
% % temptemp=temp(find(temp));
% % ccxlinessnake(k)={temptemp};
% % end

for k=1:numline
A=ccxzonelines(k,:);
temp=0;
temp(1)=A(1);
c=2;
for i=2:numel(A)
a=find(temp==A(i));
if(numel(a)==0 && A(i)~=0)
temp(c)=A(i);c=c+1;
end
end
temptemp=temp(find(temp));
ccxlinessnake(k)={temptemp};
end


%% Display the ccx of each line
for k=1:numline
    ccxtemp=ccxlinessnake{k};
    for j=1:numel(ccxtemp)
    Matxzone(k,j)=ccxtemp(j);
    end
end

%% result by colors true
%L3=zeros(h,w);
L3=L2;
% for k=1:h
%     for l=1:w
%         if(L2(k,l)~=0)
%             %for hk=1:numline
% [idxl f]=find(Matxzone==L2(k,l));
%             %end
% rep=0;
% if(numel(idxl)~=0)
% pair=mod(idxl,2);
% if(pair==0)
%     rep=2;
% else
%     rep=1;
% end
% 
% L3(k,l)=rep;
%  
% end
%         end
%     end
% end
for k=1:h
    for l=1:w
        if(L2(k,l)~=0)
           
L3(k,l)=L1(k,l);
 
        end
        
    end
end

%L3
RGB2 = label2rgb(L3, 'spring', 'w', 'shuffle');
figure('Toolbar','none','Name','Final result each color represent a line','NumberTitle','off'),imshow(RGB2);
Matxzone
