%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Santosh K.C.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Starting file.
%% 
% [x,y,t,c] = bdry_extract_3(imBW);
% [xSample,ySample,tSample] = get_samples_1(x,y,t,nsamp); %%% One can use get_samples_2.m as well.
% contourPoints = [xSample ySample tSample];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dirName = 'ShapeContext';

cd(dirModelParts);

fileName = dir(fileType);

mkdir(dirName); 

for j = 1:length(fileName)
    disp(['     ' dirName ' : image j = ',num2str(j)]);
    [pathstr, name] = fileparts(fileName(j).name);
    im = imread(fileName(j).name);
    
	if isa(im,'logical')
		imBW = im;
	else
	    imBW = im2bw(im,graythresh(double(im)));
	end

    [x,y,t,c] = bdry_extract_3(imBW);
    [xSample,ySample,tSample] = get_samples_1(x,y,t,nsamp);
    %[xSample,ySample,tSample] = get_samples_2(x,y,t,nsamp);
    
    contourPoints = [xSample ySample tSample];
    
    % save to disk
    save(fullfile(dirName,...
        strcat('contour_',name,'.mat')),'contourPoints');
        
    if saveFigure
        f = figure('visible','off');
        imshow(imBW,[],'Border','tight'); 
        [imSizeH,imSizeW] = size(imBW); dpi = 100;
        set(f,'paperposition',[0 0 imSizeW/dpi imSizeH/dpi]);
        set(f,'papersize',[imSizeW/dpi imSizeH/dpi]);
        hold on; % plot(x,y,'*');
        plot(xSample,ySample,'*','MarkerEdgeColor','r'); hold off;
        print(f,sprintf('-r%d',dpi),'-dpng',...
            fullfile(dirName,strcat('contour_',name,'.png')));
        close;
    end
end

cd(pathCur);
